"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.loginWithMetamask = void 0;
const web3_1 = __importDefault(require("web3"));
// let Web3 = require("web3");
let web3;
function loginWithMetamask(_networkId, message) {
    return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
        try {
            console.log("Metamask:", window.ethereum.isMetaMask);
            if (window.ethereum.isMetaMask) {
                web3 = new web3_1.default(window.ethereum);
                try {
                    // Requestv account access if needed
                    yield window.ethereum.enable();
                    const accounts = yield web3.eth.getAccounts();
                    const networkId = yield web3.eth.net.getId();
                    console.log("accounts:", accounts);
                    console.log("networkid:", networkId);
                    if (networkId !== _networkId) {
                        console.log("change");
                        yield window.ethereum.request({
                            method: "wallet_switchEthereumChain",
                            params: [{ chainId: web3.utils.toHex(_networkId) }],
                        });
                        //   throw Error("Please switch to the correct network id!!");
                    }
                    // sign the message
                    const receipt = yield web3.eth.personal.sign(message, accounts[0], "");
                    console.log("receipt:", receipt);
                    resolve({ account: accounts[0], msg_receipt: receipt });
                }
                catch (error) {
                    console.log("error", error);
                    reject("Error while login with metamask");
                }
            }
            else {
                reject("Metamask wallet not found!!");
            }
        }
        catch (error) {
            console.log("error:", error);
            reject();
        }
    }));
}
exports.loginWithMetamask = loginWithMetamask;
