const rblock = require('../index')
const abi = require('./erc20-abi.json')
const PROVIDER = 'https://rpc.ankr.com/polygon_mumbai'
const PRIVATE_KEY =
  '1febfa1ae9654ad43669492f34feaef9d5e4c55d24fd24a09a973b0b817dde55'
const CONTRACT_ADDRESS = '0xb1f6643A90594ac53842D6740155EdACb015Fe7f'

async function init() {
  // set provider
  await rblock.web3.init(PROVIDER)
  let balance = await rblock.web3.getBalance(
    '0x36d694353AaD9Ed2519EDbAC1eE94c6478Ec62F7'
  )
  console.log(`\nThe balance is ${balance}`)

  //SIGN TRANSACTION
  const txn = {
    to: '0xEF1B40D1094117336DD979F69e54f98930e62274',
    value: '10000000000000',
    gas: 2000000,
  }
  const signedTransaction = await rblock.web3.signTransaction(txn, PRIVATE_KEY)
  console.log(
    `\nSigned Transaction: \n${JSON.stringify(signedTransaction, null, 2)}`
  )

  // SEND SIGNED TRANSACTION
  const receipt = await rblock.web3.sendTransaction(
    signedTransaction.rawTransaction
  )
  console.log(
    `\nReceipt for transaction: \n${JSON.stringify(receipt, null, 2)}`
  )

  // CONTRACT EXECUTION
  const contract = await rblock.web3.initContract(
    PROVIDER,
    abi,
    CONTRACT_ADDRESS
  )
  let totalSupply = await contract.methods.totalSupply().call()
  console.log(`\n Total supply ${totalSupply}`)
  return
}

init()
